﻿namespace Connected.Collections.Concurrent;

public enum DispatcherProcessBehavior
{
	Parallel = 1,
	Queued = 2
}

public interface IDispatcher<TArgs, TJob> : IDisposable
	where TJob : IDispatcherJob<TArgs>
{
	bool Dequeue(out TArgs? item);
	bool Enqueue(TArgs item);
	bool Enqueue(string queue, TArgs item);
	DispatcherProcessBehavior Behavior { get; }

	CancellationToken CancellationToken { get; }
	void Cancel();
}
