﻿using Connected.Expressions.Collections;
using System.Collections.ObjectModel;
using System.Linq.Expressions;

namespace Connected.Expressions;

public sealed class ClientJoinExpression : DatabaseExpression
{
    public ClientJoinExpression(ProjectionExpression projection, IEnumerable<Expression> outerKey, IEnumerable<Expression> innerKey)
         : base(DatabaseExpressionType.ClientJoin, projection.Type)
    {
        OuterKey = outerKey.ToReadOnly();
        InnerKey = innerKey.ToReadOnly();
        Projection = projection;
    }

    public ReadOnlyCollection<Expression> OuterKey { get; }
    public ReadOnlyCollection<Expression> InnerKey { get; }
    public ProjectionExpression Projection { get; }
}